--Order of Battle - Aircraft/Helicopter
--organized in units (squadrons/regiments) containing a number of aircraft
--Campaign Version-V20.00

-- Miguel Fichier Revision M42
------------------------------------------------------------------------------------------------------- 

-- miguel21 modification M42 : liveryModex ajoute des Skin lié au numero de l avion
-- Miguel21 modification M33.e 	Custom Briefing (e: divers)
-- ATO_G_adjustment02 TASK Coef


--[[ Unit Entry Example ----------------------------------------------------------------------------

[1] = {
	inactive = true,								--true if unit is not active
	player = true,									--true for player unit
	name = "527 TFS",								--unit name
	type = "F-5E-3",								--aircraft type
	helicopter = true,								--true for helicopter units
	country = "USA",								--unit country
	livery = {"USAF Euro Camo"},					--unit livery
	liveryModex = {									--unit livery Modex  (optional)
		[100] = "VF-101 Dark",
		[110] = "VF-101 Grim Reapers Low Vis",
		},
	base = "Groom Lake AFB",						--unit base
	skill = "Random",								--unit skill
	tasks = {										--list of eligible unit tasks. Note: task names do not necessary match DCS tasks)
		["AWACS"] = true,							
		["Anti-ship Strike"] = true,
		["CAP"] = true,
		["Fighter Sweep"] = true,	
		["Intercept"] = true,
		["Reconnaissance"] = true,
		["Refueling"] = true,
		["Strike"] = true,							--Generic air-ground task (replaces "Ground Attack", "CAS" and "Pinpoint Strike")
		["Transport"] = true,
		["Escort"] = true,							--Support task: Fighter escort for package
		["SEAD"] = true,							--Support task: SEAD escort for package
		["Escort Jammer"] = true,					--Support task: Single airraft in center of package for defensive jamming
		["Flare Illumination"] = true,				--Support task: Illuminate target with flares for package
		["Laser Illumination"] = true,				--Support task: Lase target for package
		["Stand-Off Jammer"] = true,				--Not implemeted yet: On-station jamming
		["Chaff Escort"] = true,					--Not implemented yet: Lay chaff corrdior ahead of package
		["A-FAC"] = true,							--Not implemented yet: Airborne forward air controller
	},
	tasksCoef = {									--unit tasks coef (optional)
		["Strike"] = 1,								-- coef normal : = 1
		["SEAD"] = 1,
		["Laser Illumination"] = 1,
		["Intercept"] = 1,
		["CAP"] = 0.2,
		["Escort"] = 3,
		["Fighter Sweep"] = 1,	
	},
	number = 12,									--number of airframes
	reserve = 18,									--replace reserve squadrons
	refuelable = false,								--aucun affichage de TACAN ou autre Frequence des TANKER dans le briefing
},

]]-----------------------------------------------------------------------------------------------------
oob_air = {
	["blue"] = {											--side 1		
		{
			name = "2-12 Cornouaille",								--unit name
			inactive = true,								--true if unit is not active
			player = false,									--player unit TESTING
			type = "Mirage-F1CE",								--aircraft type
			country = "France",								--unit country
			livery = {"France Air Force (FICTIONAL C VERSION)"},					--unit livery
			base = "Bandar Abbas Intl",							--unit base
			skill = "High",									--unit skill
			tasks = {										--unit tasks
				["CAP"] = true,
				["Intercept"] = true,
				["Escort"] = true,
				["Fighter Sweep"] = true,
				["Strike"] = true,
			},
			tasksCoef = {									--unit tasks coef (optional)
				["Strike"] = 2,								-- coef normal : = 1
				["SEAD"] = 1,
				["Laser Illumination"] = 1,
				["Intercept"] = 3,
				["CAP"] = 2,
				["Escort"] = 1,
				["Fighter Sweep"] = 0.5,
				["Anti-ship Strike"] = 0.5,
			},
			number = 12,
			reserve = 18,
		},
		{
			name = "3-30 Lorraine",								--unit name
			inactive = false,								--true if unit is not active
			player = true,									--player unit TESTING
			type = "Mirage-F1EE",								--aircraft type
			country = "France",								--unit country
			livery = {"EC 330 Lorraine"},					--unit livery
			base = "Bandar Abbas Intl",							--unit base
			skill = "High",									--unit skill
			tasks = {										--unit tasks
				["CAP"] = true,
				["Intercept"] = true,
				["Escort"] = true,
				["Fighter Sweep"] = true,
				["Strike"] = true,
			},
			tasksCoef = {									--unit tasks coef (optional)
				["Strike"] = 2,								-- coef normal : = 1
				["SEAD"] = 1,
				["Laser Illumination"] = 1,
				["Intercept"] = 3,
				["CAP"] = 2,
				["Escort"] = 1,
				["Fighter Sweep"] = 0.5,
				["Anti-ship Strike"] = 0.5,
			},
			number = 12,
			reserve = 18,
		},
		{
			name = "93eme ERV",								--unit name
			inactive = false,								--true if unit is not active
			player = false,									--player unit
			type = "KC135MPRS",								--aircraft type
			country = "France",								--unit country
			livery = "93-CA",									--unit livery
			base = "Bandar Abbas Intl",							--unit base
			skill = "High",								--unit skill
			tasks = {										--unit tasks
				["Refueling"] = true,
			},
			number = 3,
			reserve = 1,
		},
		{
			name = "4eme RHA",								--unit name
			inactive = false,								--true if unit is not active
			player = false,									--player unit
			type = "SA342M",								--aircraft type
			helicopter = true,
			country = "France",								--unit country
			livery = {"Desert Storm FR Sand"},										--unit livery
			base = "Paris-FARP",								--unit base
			skill = "high",								--unit skill
			tasks = {										--unit tasks
				["Strike"] = true,				
			},
			number = 2,
			reserve = 12,
		},
		{
			inactive = false,								--true if unit is not active
			player = false,									--player unit
			name = "SAR Det 1",								--unit name
			type = "UH-1H",								--aircraft type
			helicopter = true,
			country = "France",								--unit country
			livery = "",									--unit livery
			sidenumber = {900, 905},						--unit range of sidenumbers (optional)
			base = "Bandar Abbas Intl",				--unit base base = "CVN-71 Theodore Roosevelt",	
			skill = "Excellent",								--unit skill
			tasks = {										--unit tasks
				["SAR"] = true,
				["CSAR"] = true,
			},
			number = 2,
			reserve = 8,
		},
		{
			name = "SAR Det 2",								--unit name
			inactive = false,								--true if unit is not active
			player = false,									--player unit
			type = "UH-1H",								--aircraft type
			helicopter = true,
			country = "France",								--unit country
			livery = "",									--unit livery
			sidenumber = {900, 905},						--unit range of sidenumbers (optional)
			base = "Paris-FARP",				--unit base base = "CVN-71 Theodore Roosevelt",	
			skill = "Excellent",								--unit skill
			tasks = {										--unit tasks
				["SAR"] = true,
				["CSAR"] = true,
			},
			number = 2,
			reserve = 4,
		},
	},
	["red"] = {												--side 2		
		{
			name = "1047 Squadron",								--unit name
			inactive = false,								--true if unit is not active
			player = false,									--player unit
			type = "Mi-24P",								--aircraft type
			helicopter = true,								--true for helicopter units
			country = "Libya",								--unit country
			livery = "",									--unit livery
			base = "Moscow-FARP",								--unit base
			skill = "high",								--unit skill
			tasks = {										--unit tasks
				["Escort"] = true,
				["Strike"] = true,
				["SAR"] = false,
				["CSAR"] = true,
			},
			number = 4,
			reserve = 18,
		},
		{
			name = "1050 Squadron",							--unit name
			type = "MiG-23MLD",							--aircraft type
			inactive = false,								--true if unit is not active
			country = "CJTF Red",							--unit country
			livery = "",					--unit livery
			base = "Kerman Airbase",						--unit base
			skill = "average",								--unit skill
			tasks = {
				["Intercept"] = true,
				["CAP"] = true,
				["Escort"] = true,
				["Fighter Sweep"] = true,
				["Strike"] = true,
			},
			tasksCoef = {									--unit tasks coef (optional)
				["Strike"] = 1,								-- coef normal : = 1
				["SEAD"] = 1,
				["Laser Illumination"] = 1,
				["Intercept"] = 2,
				["CAP"] = 1,
				["Escort"] = 1,
				["Fighter Sweep"] = 1,	
			},
			number = 6,
			reserve = 24,
		},
		{
			name = "1049 Squadron",							--unit name
			type = "MiG-23MLD",							--aircraft type
			inactive = false,								--true if unit is not active
			country = "CJTF Red",							--unit country
			livery = "",					--unit livery
			base = "Jiroft Airport",						--unit base
			skill = "average",								--unit skill
			tasks = {
				["Intercept"] = true,
				["CAP"] = true,
				["Escort"] = false,
				["Fighter Sweep"] = false,
				["Strike"] = false,
			},
			tasksCoef = {									--unit tasks coef (optional)
				["Strike"] = 1,								-- coef normal : = 1
				["SEAD"] = 1,
				["Laser Illumination"] = 1,
				["Intercept"] = 2,
				["CAP"] = 1,
				["Escort"] = 1,
				["Fighter Sweep"] = 1,	
			},
			number = 2,
			reserve = 12,
		},
		{
			name = "1051 Squadron",							--unit name
			type = "Su-17M4",							--aircraft type
			country = "CJTF Red",							--unit country
			livery = "",					--unit livery
			base = "Kerman Airbase",						--unit base
			skill = "average",								--unit skill
			tasks = {
				["Intercept"] = false,
				["CAP"] = false,
				["Escort"] = false,
				["Fighter Sweep"] = false,
				["Strike"] = true,
			},
			tasksCoef = {									--unit tasks coef (optional)
				["Strike"] = 1.5,								-- coef normal : = 1
				["SEAD"] = 1,
				["Laser Illumination"] = 1,
				["Intercept"] = 2,
				["CAP"] = 1,
				["Escort"] = 0.5,
				["Fighter Sweep"] = 0.2,	
			},
			number = 6,
			reserve = 22,
		},
		{
			name = "1052 Squadron",								--unit name
			inactive = false,								--true if unit is not active
			player = false,									--player unit
			type = "Tu-22M3",								--aircraft type
			country = "CJTF Red",								--unit country
			livery = {""},			--unit livery
			base = "Tripoli Airbase",								--unit base
			skill = "high",								--unit skill
			tasks = {										--unit tasks
				["Strike"] = true,
				["Anti-ship Strike"] = false,				
			},
			tasksCoef = {									--unit tasks coef (optional)
				["Strike"] = 2,								-- coef normal : = 1
				["SEAD"] = 1,
				["Laser Illumination"] = 1,
				["Intercept"] = 1,
				["CAP"] = 1,
				["Escort"] = 1,
				["Fighter Sweep"] = 1,
				["Anti-ship Strike"] = 1.5,
			},
			number = 2,
			reserve = 12,
		},
		{
			name = "1st Libyan SAR",	--unit name
			player = false,									--player unit
			inactive = false,
			type = "Mi-8MT",								--aircraft type
			helicopter = true,
			country = "Libya",								--unit country
			livery = {""},					--unit livery
			base = "Kerman Airbase",							--unit base
			skill = "High",									--unit skill
			tasks = {										--unit tasks
				["CAP"] = false,
				["Escort"] = false,
				["Fighter Sweep"] = false,
				["Strike"] = false,
				["Anti-ship Strike"] = false,
				["SAR"] = true,
				["CSAR"] = true,
			},
			tasksCoef = {									--unit tasks coef (optional)
				["Strike"] = 1,								-- coef normal : = 1
				["SEAD"] = 1,
				["Laser Illumination"] = 1,
				["Intercept"] = 1,
				["CAP"] = 1,
				["Escort"] = 1,
				["Fighter Sweep"] = 1,
				["Anti-ship Strike"] = 1,
				["SAR"] = 2,
				["CSAR"] = 2,
			},
			number = 2,
			reserve = 12,
		},
		{
			name = "2nd Libyan SAR",	--unit name
			player = false,									--player unit
			inactive = false,
			type = "Mi-8MT",								--aircraft type
			helicopter = true,
			country = "Libya",								--unit country
			livery = {""},					--unit livery
			base = "Jiroft Airport",							--unit base
			skill = "High",									--unit skill
			tasks = {										--unit tasks
				["CAP"] = false,
				["Escort"] = false,
				["Fighter Sweep"] = false,
				["Strike"] = false,
				["Anti-ship Strike"] = false,
				["SAR"] = true,
				["CSAR"] = true,
			},
			tasksCoef = {									--unit tasks coef (optional)
				["Strike"] = 1,								-- coef normal : = 1
				["SEAD"] = 1,
				["Laser Illumination"] = 1,
				["Intercept"] = 1,
				["CAP"] = 1,
				["Escort"] = 1,
				["Fighter Sweep"] = 1,
				["Anti-ship Strike"] = 1,
				["SAR"] = 2,
				["CSAR"] = 2,
			},
			number = 2,
			reserve = 6,
		},
	},
}

--List of aliases to replace type names in briefing/debriefing
TypeAlias = {
["Mi-24P"] = "Mi-25",
["Su-17M4"] = "Su-22",
["KC135MPRS"] = "C-135FR",

}




